CREATE VIEW PRODUCTION_VOLUME
(
 VOLUME_DATE	timestamp,
 PERIOD_TYPE	string	(100),
 OIL	bigdecimal	(15,4),
 OIL_POT	bigdecimal	(15,4),
 OIL_UOM	string	(20),
 GAS	bigdecimal	(15,4),
 GAS_POT	bigdecimal	(15,4),
 GAS_UOM	string	(20),
 WATER	bigdecimal	(15,4),
 WATER_POT	bigdecimal	(15,4),
 WATER_UOM	string	(20),
 LIQUID	bigdecimal	(15,4),
  LIQUID_POT	bigdecimal	(15,4),
  GAS_BOE	bigdecimal	(15,4),
 GAS_BOE_POT	bigdecimal(15,4),
 INJ_WATER	bigdecimal	(15,4),
 INJ_WATER_POT 	bigdecimal(15,4),
 INJ_STEAM	bigdecimal	(15,4),
 INJ_STEAM_POT	bigdecimal(15,4),
 INJ_STEAM_UOM	string(20),
 GOR	bigdecimal	(15,4),
 GOR_UOM	string	(20),
 WC	bigdecimal	(15,4),
 WC_UOM	string	(20),
 WOR	bigdecimal	(15,4),
 WOR_UOM	string	(20),
 GOR_POT	bigdecimal	(15,4),
 WC_POT	bigdecimal	(15,4),
 WOR_POT	bigdecimal	(15,4),
 OC	bigdecimal	(15,4),
 OC_UOM string(20),
 OC_POT	bigdecimal	(15,4),
 OGR	bigdecimal	(15,4),
 OGR_UOM string(20),
 OGR_POT	bigdecimal	(15,4),
CUM_OIL	bigdecimal	(15,4),
CUM_OIL_POT	bigdecimal	(15,4),
CUM_GAS	bigdecimal	(15,4),
CUM_GAS_POT	bigdecimal	(15,4),
CUM_WATER	bigdecimal	(15,4),
CUM_WATER_POT	bigdecimal	(15,4),
CUM_LIQUID	bigdecimal	(15,4),
CUM_LIQUID_POT	bigdecimal	(15,4),
CUM_GAS_BOE	bigdecimal	(15,4),
CUM_GAS_BOE_POT	bigdecimal	(15,4),
CUM_INJ_WATER	bigdecimal	(15,4),
CUM_INJ_WATER_POT	bigdecimal	(15,4),
CUM_INJ_STEAM	bigdecimal	(15,4),
CUM_INJ_STEAM_POT	bigdecimal	(15,4),
CUM_GOR	bigdecimal	(15,4),
CUM_WC	bigdecimal	(15,4),
CUM_WOR	bigdecimal	(15,4),
CUM_GOR_POT	bigdecimal	(15,4),
CUM_WC_POT	bigdecimal	(15,4),
CUM_WOR_POT	bigdecimal	(15,4),
CUM_OC	bigdecimal	(15,4),
CUM_OC_POT	bigdecimal	(15,4),
CUM_OGR	bigdecimal	(15,4),
CUM_OGR_POT	bigdecimal	(15,4),
CD_OIL	bigdecimal	(15,4),
CD_OIL_POT	bigdecimal	(15,4),
CD_GAS	bigdecimal	(15,4),
CD_GAS_POT	bigdecimal	(15,4),
CD_WATER	bigdecimal	(15,4),
CD_WATER_POT	bigdecimal	(15,4),
CD_LIQUID	bigdecimal	(15,4),
CD_LIQUID_POT	bigdecimal	(15,4),
CD_GAS_BOE	bigdecimal	(15,4),
CD_GAS_BOE_POT	bigdecimal	(15,4),
CD_INJ_WATER	bigdecimal	(15,4),
CD_INJ_WATER_POT	bigdecimal	(15,4),
CD_INJ_STEAM	bigdecimal	(15,4),
CD_INJ_STEAM_POT	bigdecimal	(15,4),
CD_GOR	bigdecimal	(15,4),
CD_WC	bigdecimal	(15,4),
CD_WOR	bigdecimal	(15,4),
CD_GOR_POT	bigdecimal	(15,4),
CD_WC_POT	bigdecimal	(15,4),
CD_WOR_POT	bigdecimal	(15,4),
CD_OC	bigdecimal	(15,4),
CD_OC_POT	bigdecimal	(15,4),
CD_OGR	bigdecimal	(15,4),
CD_OGR_POT	bigdecimal	(15,4),
 ENTITY_ID	string	(100)	NOT NULL	, 
 ENTITY_NAME	string	(255),
 ENTITY_TYPE string(100),
 NETWORK_ID	string	(40),
 NETWORK_NAME	string	(255),
 SOURCE	string	(100),
 ROW_QUALITY	string	(100),
 ROW_CHANGED_BY	string	(100),
 ROW_CHANGED_DATE	timestamp,
 ROW_CREATED_DATE	timestamp,
 ROW_CREATED_BY	string	(100),
 ACTIVE_IND	string	(1),
 VOL_ID	string	(40)	NOT NULL	,
 LEVEL1_ID	string	(40),
 LEVEL1_NAME	string	(255),
 LEVEL1_TYPE	string	(100),
 LEVEL2_ID	string	(40),
 LEVEL2_NAME	string	(255),
 LEVEL2_TYPE	string	(100),
 LEVEL3_ID	string	(40),
 LEVEL3_NAME	string	(255),
 LEVEL3_TYPE	string	(100),
 LEVEL4_ID	string	(40),
 LEVEL4_NAME	string	(255),
 LEVEL4_TYPE	string	(100),
 LEVEL5_ID	string	(40),
 LEVEL5_NAME	string	(255),
 LEVEL5_TYPE	string	(100),
 LEVEL6_ID	string	(40),
 LEVEL6_NAME	string	(255),
 LEVEL6_TYPE 	string	(100),
CONSTRAINT PK_PRODUCTION_VOLUME PRIMARY KEY (VOL_ID))
OPTIONS (UPDATABLE 'FALSE', PRODUCTION_VOLUME.IMPLEMENTED 'TRUE')
AS
 ( 
 SELECT
cast(DD.FORMATTEDDATE AS timestamp) AS	VOLUME_DATE,
cast(FPS.PERIOD_ID as string) AS PERIOD_TYPE,
FPS.OIL_ALLOCATED_VOLUME AS	 OIL,
FPS.OIL_PREDICTED_VOLUME AS	 OIL_POT,
cast(OIL.UOM_NAME as string) AS OIL_UOM,
FPS.GAS_ALLOCATED_VOLUME AS	 GAS,
FPS.GAS_PREDICTED_VOLUME AS	 GAS_POT,
cast(GAS.UOM_NAME as string) AS GAS_UOM,
FPS.WATER_ALLOCATED_VOLUME AS WATER,
FPS.WATER_PREDICTED_VOLUME AS WATER_POT,
cast(WATER.UOM_NAME as string) AS WATER_UOM,
FPS.LIQUID_ALLOC_VOLUME AS	LIQUID,
FPS.LIQUID_PREDICTED_VOLUME AS	LIQUID_POT,
FPS.GAS_BOE AS GAS_BOE,
FPS.GAS_BOE_POT  AS	GAS_BOE_POT,
FPS.WATER_INJ_VOLUME AS INJ_WATER,
FPS.WATER_INJ_PREDICTED_VOLUME AS INJ_WATER_POT ,
FPS.INJ_STEAM AS INJ_STEAM,
FPS.INJ_STEAM_POT AS INJ_STEAM_POT,
cast(INJ_S.UOM_NAME AS string) AS INJ_STEAM_UOM,
FPS.GOR,
cast(GAS.UOM_NAME as string) || '/' || cast(OIL.UOM_NAME as string),
FPS.WCT,
cast(WATER.UOM_NAME as string) || '/' || cast(OIL.UOM_NAME as string),
FPS.WOR,
cast(WATER.UOM_NAME as string) || '/' || cast(OIL.UOM_NAME as string),
FPS.GOR_PREDICTED AS GOR_POT,
FPS.WCT_PREDICTED AS	 WC_POT,
FPS.WOR_PREDICTED AS WOR_POT,
FPS.OCT,
cast(OIL.UOM_NAME as string) || '/' || cast(WATER.UOM_NAME as string),
FPS.OCT_PREDICTED AS OC_POT,
FPS.OGR,
cast(OIL.UOM_NAME as string) || '/' || cast(GAS.UOM_NAME as string),
FPS.OGR_PREDICTED AS OGR_POT,
FPS.CUM_OIL,
FPS.CUM_OIL_POT,
FPS.CUM_GAS,
FPS.CUM_GAS_POT,
FPS.CUM_WATER_VOLUME,
FPS.CUM_WATER_POT,
FPS.CUM_LIQUID,
FPS.CUM_LIQUID_POT,
FPS.CUM_GAS_BOE AS	CUM_GAS_BOE,
FPS.CUM_GAS_BOE_POT AS	CUM_GAS_BOE_POT,
FPS.CUM_INJ_WATER AS CUM_INJ_WATER,
FPS.CUM_INJ_WATER_POT AS CUM_INJ_WATER_POT,
FPS.CUM_INJ_STEAM AS	CUM_INJ_STEAM,
FPS.CUM_INJ_STEAM_POT AS	CUM_INJ_STEAM_POT,
FPS.CUM_GOR,
FPS.CUM_WCT,
FPS.CUM_WOR AS	CUM_WOR,
FPS.CUM_GOR_POT,
FPS.CUM_WCT_POT,
FPS.CUM_WOR_POT,
FPS.CUM_OCT,
FPS.CUM_OCT_POT,
FPS.CUM_OGR AS CUM_OGR,
FPS.CUM_OGR_POT,
FPS.CD_OIL,
FPS.CD_OIL_POT,
FPS.CD_GAS,
FPS.CD_GAS_POT,
FPS.CD_WATER,
FPS.CD_WATER_POT,
FPS.CD_LIQUID,
FPS.CD_LIQUID_POT,
FPS.CD_GAS_BOE AS	CD_GAS_BOE,
FPS.CD_GAS_BOE_POT AS	CD_GAS_BOE_POT,
FPS.CD_INJ_WATER AS CD_INJ_WATER,
FPS.CD_INJ_WATER_POT AS CD_INJ_WATER_POT,
FPS.CD_INJ_STEAM AS	CD_INJ_STEAM,
FPS.CD_INJ_STEAM_POT AS	CD_INJ_STEAM_POT,
FPS.CD_GOR,
FPS.CD_WCT,
FPS.CD_WOR AS	CD_WOR,
FPS.CD_GOR_POT,
FPS.CD_WCT_POT,
FPS.CD_WOR_POT,
FPS.CD_OCT,
FPS.CD_OCT_POT,
FPS.CD_OGR AS CD_OGR,
FPS.CD_OGR_POT,
cast(E.ENTITY_ID as string),
cast(E.ENTITY_NAME as string),
cast(FPS.W_WC_FAC_IND AS string),
cast(FPS.DIM_NETWORK_KEY AS string) AS	 NETWORK_ID,
cast(N.NETWORK_NAME AS string) AS NETWORK_NAME,
NULL AS	 SOURCE,
NULL AS	 ROW_QUALITY,
NULL AS	 ROW_CHANGED_BY,
NULL AS	 ROW_CHANGED_DATE,
NULL AS	 ROW_CREATED_DATE,
NULL AS	 ROW_CREATED_BY,
NULL AS	 ACTIVE_IND,
cast(FPS.FACT_PROD_SUMMARY_KEY as string) AS VOL_ID,
cast(DAH.LEVEL1_ID as string),
cast(DAH.LEVEL1_NAME as string),
cast(DAH.LEVEL1_TYPE as string),
cast(DAH.LEVEL2_ID as string),
cast(DAH.LEVEL2_NAME as string),
cast(DAH.LEVEL2_TYPE as string),
cast(DAH.LEVEL3_ID as string),
cast(DAH.LEVEL3_NAME as string),
cast(DAH.LEVEL3_TYPE as string),
cast(DAH.LEVEL4_ID as string),
cast(DAH.LEVEL4_NAME as string),
cast(DAH.LEVEL4_TYPE as string),
cast(DAH.LEVEL5_ID as string),
cast(DAH.LEVEL5_NAME as string),
cast(DAH.LEVEL5_TYPE as string),
cast(DAH.LEVEL6_ID as string),
cast(DAH.LEVEL6_NAME as string),
cast(DAH.LEVEL6_TYPE as string)  
 FROM PDMDimSrc.FactProdSummary AS FPS
 INNER JOIN (SELECT DWC.DIM_WELLCOMPL_KEY AS ENTITY_KEY, DWC.WELL_OR_COMPLETION_ID AS ENTITY_ID, DWC.WELL_COMPLETION_NAME AS ENTITY_NAME, DWC.DIM_ASSETHIERARCHY_KEY AS DIM_ASSETHIERARCHY_KEY 
					FROM PDMDimSrc.DimWellCompletion DWC WHERE DWC.WELL_OR_COMPLETION = 'W'
					UNION ALL 
				 SELECT DF.DIM_FACILITY_KEY AS ENTITY_KEY, DF.FACILITY_ID AS ENTITY_ID, DF.FACILITY_NAME AS ENTITY_NAME, DF.DIM_ASSETHIERARCHY_KEY 
					FROM PDMDimSrc.DimFacility DF
				 )E ON FPS.W_WC_FAC_KEY = E.ENTITY_KEY
 LEFT OUTER JOIN PDMDimSrc.DimUnitOfMeasure AS WATER ON FPS.WATER_VOLUME_UOM_KEY = WATER.DIM_UOM_KEY 
 LEFT OUTER JOIN PDMDimSrc.DimUnitOfMeasure AS OIL ON FPS.OIL_VOLUME_UOM_KEY = OIL.DIM_UOM_KEY 
 LEFT OUTER JOIN PDMDimSrc.DimUnitOfMeasure AS GAS ON FPS.GAS_VOLUME_UOM_KEY = GAS.DIM_UOM_KEY
  LEFT OUTER JOIN PDMDimSrc.DimUnitOfMeasure AS INJ_S ON FPS.INJ_STEAM_UOM_KEY = INJ_S.DIM_UOM_KEY
 LEFT OUTER JOIN PDMDimSrc.DimDate AS DD ON FPS.DATE_KEY = DD.DATE_KEY
 LEFT OUTER JOIN PDMDimSrc.DimNetwork N ON FPS.DIM_NETWORK_KEY = N.DIM_NETWORK_KEY
  LEFT OUTER JOIN PDMDimSrc.DimAssetHierarchy AS DAH ON E.DIM_ASSETHIERARCHY_KEY = DAH.Dim_ASSETHIERARCHY_KEY 
 );
 